<?
/** 
Oreon is developped with GPL Licence 2.0 :
http://www.gnu.org/licenses/gpl.txt
Developped by : Jean Baptiste Gouret - Julien Mathis - Romain Le Merlus

The Software is provided to you AS IS and WITH ALL FAULTS.
OREON makes no representation and gives no warranty whatsoever,
whether express or implied, and without limitation, with regard to the quality,
safety, contents, performance, merchantability, non-infringement or suitability for
any particular or intended purpose of the Software found on the OREON web site.
In no event will OREON be liable for any direct, indirect, punitive, special,
incidental or consequential damages however they may arise and even if OREON has
been previously advised of the possibility of such damages.

For information : contact@oreon.org
*/
?>
<td width="85%" valign="top" align="left">
<?

class Camembert
{
	// Chart Parameter
	var $ChartDiameter;
	var $ChartFont;
	var $ChartFontHeight;
	var $ChartData;
	var $ChartLabel;
	var $FileName;
	// Graphique Size
	var $ChartWidth;
	var $ChartHeight;
	var $Image;
	var $ChartCenterX;
	var $ChartCenterY;
	
	var $ColorBody;
	var $ColorBorder;
	var $ColorText;
	var $ColorSlice;
	var $CurrentColor;
	
	var $ChartTotal;
	
	
	function Camembert($ChartDiameter, $font, $fontheight, $ChartData, $ChartLabel, $filename)
	{	
		$this->ChartDiameter = $ChartDiameter;
		$this->ChartFont = $font;
		$this->ChartFontHeight = $fontheight;
		$this->ChartData = $ChartData;
		$this->ChartLabel = $ChartLabel;
		
		$this->FileName = $filename;
		
		$this->ChartWidth = $this->ChartDiameter + 20;
		$this->ChartHeight = $this->ChartDiameter + 20 + (($this->ChartFontHeight + 2) * count($this->ChartData));
 		// Determine total of all values
		for ($index = 0; $index < count($this->ChartData); $index++)
			{$this->ChartTotal += $this->ChartData[$index];}
		
		$this->ChartCenterX = $this->ChartDiameter / 2 + 10;
		$this->ChartCenterY = $this->ChartDiameter / 2 + 10;
		// Create Image
		$this->Image = imagecreate($this->ChartWidth, $this->ChartHeight);
		$this->AllocateColor();
		$this->FillBackGroud();
		$this->draw_each_slice();
		
	}
	
	function CirclePoint($degrees, $diameter)
	{
		$x = cos(deg2rad($degrees)) * ($diameter / 2);
		$y = sin(deg2rad($degrees)) * ($diameter / 2);
		return (array($x, $y));
	}
	
	function FillBackGroud()
	{
		imagefill($this->Image, 0, 0, $this->ColorBody);
	}
	
	function AllocateColor()
	{
		$this->ColorBody = imagecolorallocate($this->Image, 255, 255, 255);
		$this->ColorBorder = imagecolorallocate($this->Image, 0, 0, 0);
		$this->ColorText = imagecolorallocate($this->Image, 0, 0, 0);
		
		$this->ColorSlice[0] = imagecolorallocate($this->Image, 0xF6, 0x48, 0x50);
		$this->ColorSlice[1] = imagecolorallocate($this->Image, 0x48, 0xF6, 0x54);
		$this->ColorSlice[2] = imagecolorallocate($this->Image, 0x48, 0x69, 0xF6);
		$this->ColorSlice[3] = imagecolorallocate($this->Image, 0xF6, 0xB2, 0x48);
		$this->ColorSlice[4] = imagecolorallocate($this->Image, 0xF7, 0xEF, 0x12);
	}
		
	function draw_each_slice()
	{
		
		$Degres = 0;
		for ($index = 0; $index < count($this->ChartData); $index++)
		{
			$StartDegres = round($Degres);
			$Degres += (($this->ChartData[$index] / $this->ChartTotal) * 360);
			$EndDegres = round($Degres);
			
			$this->CurrentColor = $this->ColorSlice[$index];
			// draw arc
			imagearc($this->Image, $this->ChartCenterX, $this->ChartCenterY, $this->ChartDiameter, $this->ChartDiameter,  $StartDegres, $EndDegres, $this->ColorBorder);
			// Draw Start line from center
			list($ArcX, $ArcY) = $this->CirclePoint($StartDegres, $this->ChartDiameter);
			imageline($this->Image, $this->ChartCenterX, $this->ChartCenterY, floor($this->ChartCenterX + $ArcX), floor($this->ChartCenterY + $ArcY), $this->ColorBorder);
			// Draw end line from center
			list($ArcX, $ArcY) = $this->CirclePoint($EndDegres, $this->ChartDiameter);
			imageline($this->Image, $this->ChartCenterX, $this->ChartCenterY, ceil($this->ChartCenterX + $ArcX), ceil($this->ChartCenterY + $ArcY), $this->ColorBorder);
			// fill Slice
			$MidPoint = round((($EndDegres - $StartDegres) / 2) + $StartDegres);
			list($ArcX, $ArcY) = $this->CirclePoint($MidPoint, $this->ChartDiameter / 2);
			imagefilltoborder($this->Image, floor($this->ChartCenterX + $ArcX), floor($this->ChartCenterY + $ArcY), $this->ColorBorder, $this->CurrentColor);
		}
		
		imagearc($this->Image, $this->ChartCenterX, $this->ChartCenterY, $this->ChartDiameter, $this->ChartDiameter, 0, 180, $this->ColorBorder);
		imagearc($this->Image, $this->ChartCenterX, $this->ChartCenterY, $this->ChartDiameter, $this->ChartDiameter, 180, 360, $this->ColorBorder);
		imagearc($this->Image, $this->ChartCenterX, $this->ChartCenterY, $this->ChartDiameter + 2, $this->ChartDiameter + 2, 0, 180, $this->ColorBorder);
		imagearc($this->Image, $this->ChartCenterX, $this->ChartCenterY, $this->ChartDiameter + 2, $this->ChartDiameter + 2, 180, 360, $this->ColorBorder);
		//imagefilltoborder($this->Image, floor($this->ChartCenterX + ($this->ChartDiameter/2) + 2), $this->ChartCenterY, $this->ColorBorder, $this->ColorSlice[3]);
		//imagejpeg($this->Image);
		$this->AffLabel();
		@imagepng($this->Image, $this->FileName); 
		if (!file_exists($this->FileName)) 
		  return FALSE; 
	}
	
	function AffLabel()
	{
		for ($index = 0; $index < count($this->ChartData); $index++)
		{
			$this->CurrentColor = $this->ColorSlice[$index % (count($this->ColorSlice))];
			$LineY = $this->ChartDiameter + 20 + ($index*($this->ChartFontHeight+2));
			
			// draw color Baox
			imagerectangle($this->Image, 10, $LineY, 10 + $this->ChartFontHeight, $LineY + $this->ChartFontHeight, $this->ColorBorder);
			imagefilltoborder($this->Image, 12, $LineY + 2, $this->ColorBorder, $this->CurrentColor);
			// Draw Label
			imagestring($this->Image, $this->ChartFont, 20 + $this->ChartFontHeight, $LineY, $this->ChartLabel[$index]. " : " .$this->ChartData[$index] . "%", $this->ColorText);
		}
	}
}

class Stat
{
	var $Hosts;
	var $Services;
	var $Host_health;
	var $Service_health;
	
	function Stat()
	{
		// init stat 
		$Host_health = 100 ;
		$Service_health = 100;
		
		// create array
		$this->Hosts = array();
		$this->Services = array();
		
		// init host value
		$this->Hosts["DOWN"] = 0;
		$this->Hosts["UP"] = 0;
		$this->Hosts["UNREACHABLE"] = 0;
		$this->Hosts["PENDING"] = 0;
		
		// init service value
		$this->Services["OK"] = 0;
		$this->Services["CRITICAL"] = 0;
		$this->Services["WARNING"] = 0;
		$this->Services["UNKNOWN"] = 0;
		$this->Services["PENDING"] = 0;
	}
	
	// return funcion 
	
	function get_host_data($str)
	{
		return $this->Hosts[$str];
	}
	
	function get_service_data($str)
	{
		return $this->Services[$str];
	}
	
	// return host data with specified category
	
	/* HOsts */
	
	function get_host_down()
	{
		return $this->Hosts["DOWN"];
	}
	
	function get_host_up()
	{
		return $this->Hosts["UP"];
	}
	
	function get_host_unreachable()
	{
		return $this->Hosts["UNREACHABLE"];
	}
	
	function get_host_pending()
	{
		return $this->Hosts["PENDING"];
	}
	
	/* Services */
	
	
	function get_service_ok()
	{
		return $this->Services["OK"];
	}
	
	function get_service_critical()
	{
		return $this->Services["CRITICAL"];
	}
	
	function get_service_warning()
	{
		return $this->Services["WARNING"];
	}
	
	function get_service_unknown()
	{
		return $this->Services["UNKNOWN"];
	}
	
	function get_service_pending()
	{
		return $this->Services["PENDING"];
	}
	
	// set funcion 
	function Set_host_data($str)
	{
		$this->Hosts[$str]++;
		$this->Set_Host_health();
	}
	
	function Set_service_data($str)
	{
		$this->Services[$str]++;
		$this->Set_Service_health();
	}
	
	// Create %age
	
	function Set_Host_health()
	{
		$total_host = $this->get_host_down() + $this->get_host_unreachable() + $this->get_host_up() + $this->get_host_pending();
		if ($this->get_host_down() != 0){
			$percentage = 100 / $total_host;
			$this->Host_health = $percentage * $this->get_host_up();
		} else 
			$this->Host_health = 100;
	}
	
	function Set_Service_health()
	{
		$total_service = $this->get_service_ok() + $this->get_service_critical() + $this->get_service_warning() + $this->get_service_unknown() + $this->get_service_pending(); 
		$critical = $this->get_service_critical() + ($this->get_service_warning() / 2);
		if ($critical != 0){
			$percentage = 100 / $total_service;
			$this->Service_health = $percentage * $this->get_service_ok();
		} else 
			$this->Service_health = 100;
	} 
	
	// Return Health
	function get_Host_health()
	{
		return $this->Host_health;
	}	
	
	function get_Service_health()
	{
		return $this->Service_health;
	}
	
	function return_color_health($h)
	{
		print $h;
		if ($h < 25)
			return "#F5574C";
		else if ($h => 25 && $h < 50)
			return "#F5C425";
		else if ($h => 50 && $h <= 75)
			return "#F7EE3B";
		else if ($h > 75)
			return "#3BF541";
	}

}
	
	$Stat = new Stat();
	$str = "";
	
	if (file_exists($Nagioscfg->stt_file ;))
		$log = fopen($Nagioscfg->stt_file ;, "r");
	else
		$log = fopen($Nagioscfg->state_retention_file, "r");
			
	// begin to read logfile
	while ($str = fgets($log))
	{
		// set last update 
		//$last_update = date("d-m-Y G:i:s");
		if (!preg_match("/^\#.*/", $str)){
			// get service stat
			if (preg_match("/^[\[\]0-9]* SERVICE[.]*/", $str)){
				$t = split(";", $str);
				$Stat->Set_service_data($t[3]);
			}	
			// get host stat
			if (preg_match("/^[\[\]0-9]* HOST[.]*/", $str)){
				$t = split(";", $str);
				$Stat->Set_host_data($t[2]);
			}	
		}
	}
	
?>
<table border=0>
<tr>
	<td width="30%">
	<? include ("tab3Top.php"); ?>
	<h1>Oreon</h1>
	<h3><? echo $lang['am_intro']; ?></h3>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->hosts))	{
			if (count($oreon->hosts) > 0)
				echo count($oreon->hosts);
		}	else
				echo "0";
		echo " <a href='?p=102' class='text10'>".$lang['h'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->hostGroups)) 	{
			if (count($oreon->hostGroups) > 0)
				echo count($oreon->hostGroups);
		} else
			echo "0";
		echo " <a href='?p=103' class='text10'>".$lang['hg'] . "</a>"; ?>
	</div>
	<? if (!strcmp($oreon->user->get_version(), "1")) { ?>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->hges)) 	{
			if (count($oreon->hges) > 0)
				echo count($oreon->hges);
		} else
			echo "0";
		echo " <a href='?p=122' class='text10'>".$lang['hge'] . "</a>"; ?>
	</div>
	<? } ?>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->hes))	{
			if (count($oreon->hes) > 0)
				echo count($oreon->hes);
		}	else
				echo "0";
		echo " <a href='?p=115' class='text10'>".$lang['he'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->hds))	{
			if (count($oreon->hds) > 0)
				echo count($oreon->hds);
		}	else
				echo "0";
		echo " <a href='?p=118' class='text10'>".$lang['hd'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->ehis))	{
			if (count($oreon->ehis) > 0)
				echo count($oreon->ehis);
		}	else
				echo "0";
		echo " <a href='?p=113' class='text10'>".$lang['ehi'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->services))	{
			if (count($oreon->services) > 0)
				echo count($oreon->services);
		}	else
				echo "0";
		echo " <a href='?p=104' class='text10'>".$lang['s'] . "</a>"; ?>
	</div>
	<? if (!strcmp($oreon->user->get_version(), "2")) { ?>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->serviceGroups)) 	{
			if (count($oreon->serviceGroups) > 0)
				echo count($oreon->serviceGroups);
		} else
			echo "0";
		echo " <a href='?p=105' class='text10'>".$lang['m_servicegroup'] . "</a>"; ?>
	</div>
	<? } ?>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->ses))	{
			if (count($oreon->ses) > 0)
				echo count($oreon->ses);
		}	else
				echo "0";	
		echo " <a href='?p=117' class='text10'>".$lang['se'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->esis))	{
			if (count($oreon->esis) > 0)
				echo count($oreon->esis);
		}	else
				echo "0";	
		echo " <a href='?p=114' class='text10'>".$lang['esi'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->sds))	{
			if (count($oreon->sds) > 0)
				echo count($oreon->sds);
		}	else
				echo "0";
		echo " <a href='?p=119' class='text10'>".$lang['sd'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->contacts))	{
			if (count($oreon->contacts) > 0)
				echo count($oreon->contacts);
		}	else
				echo "0";	
		echo " <a href='?p=106' class='text10'>".$lang['c'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->contactGroups))	{
			if (count($oreon->contactGroups) > 0)
				echo count($oreon->contactGroups);
		}	else
				echo "0";
		echo " <a href='?p=107' class='text10'>".$lang['cg'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->time_periods))	{
			if (count($oreon->time_periods) > 0)
				echo count($oreon->time_periods);
		}	else
				echo "0";
		echo " <a href='?p=108' class='text10'>".$lang['tp'] . "</a>"; ?>
	</div>
	<div style="padding: 7px;">
		<? 
		if (isset($oreon->commands))	{
			if (count($oreon->commands) > 0)
				echo count($oreon->commands);
		}	else
				echo "0";
		echo " <a href='?p=109' class='text10'>".$lang['cmd'] . "</a>"; ?>
	</div>
	<? include ("tab3Bot.php"); ?>
	</td>
	<td width="80%" align="center" valign="top">
	<?
	// Camembert for Host
	/*
	$total = $Stat->get_host_down() + $Stat->get_host_up() + $Stat->get_host_unreachable() + $Stat->get_host_pending();
	
	$CharData = array($Stat->get_host_down() / $total * 100, $Stat->get_host_up() / $total * 100, $Stat->get_host_unreachable() / $total * 100,$Stat->get_host_pending() / $total * 100);
	$CharLabel = array("down", "up", "unreachable", "pending");
	
	$Camembert = new Camembert("120", "2", imagefontheight("2"), $CharData, $CharLabel, "./tmp/host.jpeg");
	// Camembert for service
	$total = $Stat->get_service_critical() + $Stat->get_service_warning() + $Stat->get_service_unknown() + $Stat->get_service_ok() + $Stat->get_service_pending();
	
	$CharData = array($Stat->get_service_critical()/$total*100, $Stat->get_service_ok()/$total*100, $Stat->get_service_unknown()/$total*100, $Stat->get_service_pending()/$total*100 , $Stat->get_service_warning()/$total*100);
	$CharLabel = array("critical", "ok", "unknown", "pending", "critical");
	$Camembert = new Camembert("120", "2", imagefontheight("2"), $CharData, $CharLabel, "./tmp/service.jpeg");
	*/
	?>
	<!--<table border=0>
	<tr>
		<td valign="top">
		<MM:BeginLock translatorClass="MM_SSI" type="ssi" orig="%3C? include (%22tab3Top.php%22); ?%3E" fileRef="tab3Top.php" depFiles="file:///E|/PFE/Dev/Oreon Labtech/tab3Top.php"><table align="center" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td background="img/tab/bd_tl_blue.gif" width="12" height="12"></td>
		<td background="img/tab/bd_t_blue.gif" height="12"></td>
		<td background="img/tab/bd_tr_blue.gif" width="12" height="12"></td>	
	</tr>
	<tr>
		<td background="img/tab/bd_l_blue.gif" width="12"></td>
		<td bgcolor="#E7E7E7"><MM:EndLock>
		<table>
			<tr>
				<td width="50"></td>
				<td><br><br><span class='text11b'><center>Hosts</center></span><br><br><a href='./oreon.php?p=303&o=h'><img src="./tmp/host.jpeg" border=0></a></td>
				<td width="50"></td>
				<td><br><br><span class='text11b'><center>Services</center></span><br><br><a href='oreon.php?p=303&o=s'><img src="./tmp/service.jpeg" border=0></a></td>
				<td width="50"></td>
			</tr>
		</table>
		<MM:BeginLock translatorClass="MM_SSI" type="ssi" orig="%3C? include (%22tab3Bot.php%22); ?%3E" fileRef="tab3Bot.php" depFiles="file:///E|/PFE/Dev/Oreon Labtech/tab3Bot.php">		</td>
		<td background="img/tab/bd_r_blue.gif" width="12"></td>
	</tr>
	<tr>
		<td background="img/tab/bd_bl_blue.gif" width="12" height="12" style="background-repeat:no-repeat"><img src='img/tab/bd_bl_blue.gif'></td>
		<td background="img/tab/bd_b_blue.gif" height="12"><img src='img/tab/bd_b_blue.gif'></td>
		<td background="img/tab/bd_br_blue.gif" width="12" height="12" style="background-repeat:no-repeat"><img src='img/tab/bd_br_blue.gif'></td>
	</tr>
</table><MM:EndLock>
		</td>
	</tr>
	</table> -->
	<table border=0>
	<tr>
		<td valign="top">
		<? include ("tab3Top.php"); ?>
		<table>
		<tr>
			<td colspan="3" align="center">
				<div  style="padding-bottom: 25px;"><span class='text11b'>Network Health<? print $Stat->Host_health ; ?> % </span></div>
				<table border=0 width="350" cellpadding="0" cellspacing="0">
					<tr>
						<td width="150" nowrap>Hosts Health</td>
						<td width="<? print $Stat->Host_health * 2 ; ?>" bgcolor="<? print $Stat->return_color_health($Stat->Host_health); ?>" height="15"><img scr='./img/blank.gif' width="1" height="1"></td>
						<td width="<? print (100 - $Stat->Host_health) * 2 ; ?>" bgcolor="#999999"><img scr='./img/blank.gif' width="1" height="1"></td>
					</tr>
				</table>
					<br>
				<table width="350" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td width="150" nowrap>Services Health<? print $Stat->Service_health * 2 ; ?> % </td>
						<td width="<? print $Stat->Service_health * 2 ; ?>" bgcolor="<? print $Stat->return_color_health($Stat->Service_health); ?>" height="15"><img scr='./img/blank.gif' width="1" height="1"></td>
						<td width="<? print (100 - $Stat->Service_health) * 2 ; ?>" bgcolor="#999999"><img scr='./img/blank.gif' width="1" height="1"></td>
					</tr>
				</table>
			</td>
		</tr>
		</table>	
		<? include ("tab3Bot.php"); ?>
	<br>
	<? include ("tab3Top.php"); ?>
		<table border=0 align="center">
			<tr>
				<td colspan="2">
				<br><span class='text11b'><center>Detail</center></span><br>
					<TABLE cellSpacing=1 cellPadding=3 width="300" border=0>
						<TR>
						  <TD colSpan=2><FONT face="verdana, arial, sans-serif" size=-1><B>Hosts</B></FONT></TD></TR>
						<TR>
						  <TD background="./img/div.gif" colSpan=2><IMG height=4 alt="" src="./img/blank.gif" width=1 border=0></TD>
						</TR>
					</TABLE>
					<TABLE cellSpacing=1 cellPadding=5 width="300" border=0>
					<TR bgColor=#eaecef>
						  <TD align=left width="25%"><b>Down&nbsp;<? print $Stat->get_host_down(); ?></b></TD>
						  <TD align=middle width="25%"><b>Unreachable&nbsp;<? print $Stat->get_host_unreachable() ?></b></TD>
						  <TD align=middle width="25%"><b>Up&nbsp;<? print $Stat->get_host_up(); ?></b></TD>
						  <TD align=middle width="25%"><b>Pending&nbsp;<? print $Stat->get_host_pending(); ?></b></TD>
						</TR>
					</TABLE>
					<br>
					<TABLE cellSpacing=1 cellPadding=3 width="300" border=0>
						<TR>
						  <TD colSpan=2><FONT face="verdana, arial, sans-serif" size=-1><B>Services</B></FONT></TD></TR>
						<TR>
						  <TD background="./img/div.gif" colSpan=2><IMG height=4 alt="" src="./img/blank.gif" width=1 border=0></TD>
						</TR>
					</TABLE>
					<TABLE cellSpacing=1 cellPadding=5 width="300" border=0>
						<TR bgColor=#eaecef>
						  <TD align=left width="20%"><b>Critical&nbsp;<? print $Stat->get_service_critical(); ?></b></TD>
						  <TD align=middle width="20%"><b>Warning&nbsp;<? print $Stat->get_service_warning(); ?></b></TD>
						  <TD align=middle width="20%"><b>Unknown&nbsp;<? print $Stat->get_service_unknown(); ?></b></TD>
						  <TD align=middle width="20%"><b>ok&nbsp;<? print $Stat->get_service_ok(); ?></b></TD>
						  <TD align=middle width="20%"><b>Pending&nbsp;<? print $Stat->get_service_pending(); ?></b></TD>
						</TR>
					</TABLE>
					</center>
				</td>
			</tr>
		</table>
		<? include ("tab3Bot.php"); ?>
		</td>
	</tr>
	</table>
	</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td valign="top" colspan=2>
	<table width="400" align="center">
	<tr>
		<td>
		
		</td>
	</tr>
	</table>
	</td>
</tr>
</table>
</td>